+++
date = "2016-01-13T13:18:00+03:00"
author = "Alan Orth"
title = "January, 2016"
tags = ["Notes"]

+++
## 2016-01-13

- Move ILRI collection `10568/12503` from `10568/27869` to `10568/27629` using the [move_collections.sh](https://gist.github.com/alanorth/392c4660e8b022d99dfa) script I wrote last year.
- I realized it is only necessary to clear the Cocoon cache after moving collections—rather than reindexing—as no metadata has changed, and therefore no search or browse indexes need to be updated.
- Update GitHub wiki for documentation of [maintenance tasks](https://github.com/ilri/DSpace/wiki/Maintenance-Tasks).

<!--more-->

## 2016-01-14

- Update CCAFS project identifiers in input-forms.xml
- Run system updates and restart the server

## 2016-01-18

- Change "Extension material" to "Extension Material" in input-forms.xml (a mistake that fell through the cracks when we fixed the others in DSpace 4 era)

## 2016-01-19

- Work on tweaks and updates for the social sharing icons on item pages: add Delicious and Mendeley (from Academicons), make links open in new windows, and set the icon color to the theme's primary color ([#157](https://github.com/ilri/DSpace/issues/157))
- Tweak date-based facets to show more values in drill-down ranges ([#162](https://github.com/ilri/DSpace/issues/162))
- Need to remember to clear the Cocoon cache after deployment or else you don't see the new ranges immediately
- Set up recipe on IFTTT to tweet new items from the CGSpace Atom feed to my twitter account
- Altmetrics' support for Handles is kinda weak, so they can't associate our items with DOIs until they are tweeted or blogged, etc first.

## 2016-01-21

- Still waiting for my IFTTT recipe to fire, two days later
- It looks like the Atom feed on CGSpace hasn't changed in two days, but there have definitely been new items
- The RSS feed is nearly as old, but has different old items there
- On a hunch I cleared the Cocoon cache and now the feeds are fresh
- Looks like there is configuration option related to this, `webui.feed.cache.age`, which defaults to 48 hours, though I'm not sure what relation it has to the Cocoon cache
- In any case, we should change this cache to be something more like 6 hours, as we publish new items several times per day.
- Work around a CSS issue with long URLs in the item view ([#172](https://github.com/ilri/DSpace/issues/172))

## 2016-01-25

- Re-deploy CGSpace and DSpace Test with latest `5_x-prod` branch
- This included the social icon fixes/updates, date-based facet tweaks, reducing the feed cache age, and fixing a layout issue in XMLUI item view when an item had long URLs

## 2016-01-26

- Run nginx updates on CGSpace and DSpace Test ([1.8.1 and 1.9.10, respectively](http://mailman.nginx.org/pipermail/nginx/2016-January/049700.html))
- Run updates on DSpace Test and reboot for new Linode kernel `Linux 4.4.0-x86_64-linode63` (first update in months)

## 2016-01-28

- Start looking at importing some Bioversity data that had been prepared earlier this week
- While checking the data I noticed something strange, there are 79 items but only 8 unique PDFs:

    $ ls SimpleArchiveForBio/ | wc -l
    79
    $ find SimpleArchiveForBio/ -iname "*.pdf" -exec basename {} \; | sort -u | wc -l
    8

## 2016-01-29

- Add five missing center-specific subjects to XMLUI item view ([#174](https://github.com/ilri/DSpace/issues/174))
- This [CCAFS item](https://cgspace.cgiar.org/handle/10568/67062) Before:

![XMLUI subjects before](/cgspace-notes/2016/01/xmlui-subjects-before.png)

- After: 

![XMLUI subjects after](/cgspace-notes/2016/01/xmlui-subjects-after.png)
